# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class SheetTransform(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SheetTransform - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'sheet': 'int',
            'sheet_name': 'str',
            'table': 'TableTransform'
        }

        self.attribute_map = {
            'sheet': 'sheet',
            'sheet_name': 'sheetName',
            'table': 'table'
        }

        self._sheet = None
        self._sheet_name = None
        self._table = None

    @property
    def sheet(self):
        """
        Gets the sheet of this SheetTransform.


        :return: The sheet of this SheetTransform.
        :rtype: int
        """
        return self._sheet

    @sheet.setter
    def sheet(self, sheet):
        """
        Sets the sheet of this SheetTransform.


        :param sheet: The sheet of this SheetTransform.
        :type: int
        """
        
        self._sheet = sheet

    @property
    def sheet_name(self):
        """
        Gets the sheet_name of this SheetTransform.


        :return: The sheet_name of this SheetTransform.
        :rtype: str
        """
        return self._sheet_name

    @sheet_name.setter
    def sheet_name(self, sheet_name):
        """
        Sets the sheet_name of this SheetTransform.


        :param sheet_name: The sheet_name of this SheetTransform.
        :type: str
        """
        
        self._sheet_name = sheet_name

    @property
    def table(self):
        """
        Gets the table of this SheetTransform.


        :return: The table of this SheetTransform.
        :rtype: TableTransform
        """
        return self._table

    @table.setter
    def table(self, table):
        """
        Sets the table of this SheetTransform.


        :param table: The table of this SheetTransform.
        :type: TableTransform
        """
        
        self._table = table

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

